package ukol.dotazy;

import html.HtmlWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import ukol.DisplayQueryResults;


public class JspUI {
    private static String prefix = "JspUI";
    private HttpServletRequest request;
    private HttpServletResponse response;
    private PrintWriter out;


    public JspUI(HttpServletRequest request,HttpServletResponse response) throws IOException {
        this.request = request;
        out = response.getWriter();
    }
    
    protected Integer select(String title, int[] ids, String[] nazvy) throws DialogException {
        String cancel = request.getParameter(prefix+"cancel");
        if(cancel != null) return null;
        
        String index = request.getParameter(prefix+"index");
        if(index != null) {
            return ids[Integer.parseInt(index)];
        }

        HtmlWriter.printHeader(out, title);
        printFormHeader();
        out.println("<select name=\""+prefix+"index\">");
        for(int i = 0; i < nazvy.length; i++) {
            out.println("\t<option value=\""+i+"\">"+nazvy[i]+"</option>");
        }
        out.println("</select><br /><br />");
        out.println("<input type=\"submit\" value=\"OK\" name=\""+prefix+"OK\" />");
        out.println("<input type=\"submit\" value=\"CANCEL\" name=\""+prefix+"cancel\" />");
        printFormFooter();
        HtmlWriter.printFooter(out);
        out.flush();
        throw new DialogException();
    }

    protected String getQuery(String title, String defaultQuery) {
        String cancel = request.getParameter(prefix+"cancel");
        if(cancel != null) return null;

        String sql = request.getParameter(prefix+"sql");
        if(sql != null) {
            return sql;
        }

        HtmlWriter.printHeader(out, title);
        printFormHeader();
        out.println("<textarea name=\""+prefix+"sql\" rows=\"8\" cols=\"70\">"+defaultQuery+"</textarea><br />");
        out.println("<input type=\"submit\" value=\"OK\" name=\""+prefix+"OK\" />");
        out.println("<input type=\"submit\" value=\"CANCEL\" name=\""+prefix+"cancel\" />");
        printFormFooter();
        HtmlWriter.printFooter(out);
        out.flush();
        throw new DialogException();
    }

    public UI.Author showAuthorDialog(String title, UI.Author author) {
        String cancel = request.getParameter(prefix+"cancel");
        if(cancel != null) return null;

        String ok = request.getParameter(prefix+"NameOK");
        if(ok != null) {
           return new UI.Author(author.id,request.getParameter(prefix+"firstName"),
                   request.getParameter(prefix+"lastName"));
        }

        HtmlWriter.printHeader(out, title);
        printFormHeader();
        out.println("<table border=\"0\">");
        out.printf("<tr><th>First name:</th><td><input type=\"text\" name=\""+prefix
                    +"firstName\" value=\"%s\"/></td></tr>",author.firstName);
        out.printf("<tr><th>Last name:</th><td><input type=\"text\" name=\""+prefix
                    +"lastName\" value=\"%s\"/></td></tr>",author.lastName);
        out.println("</table>");
        out.println("<input type=\"submit\" value=\"OK\" name=\""+prefix+"NameOK\" />");
        out.println("<input type=\"submit\" value=\"CANCEL\" name=\""+prefix+"cancel\" />");
        printFormFooter();
        HtmlWriter.printFooter(out);
        out.flush();
        throw new DialogException();
    }

    private void printFormHeader() {
        out.println("<form method=\"post\" action=\".\"><fieldset>");

        Enumeration e = request.getParameterNames();
        while(e.hasMoreElements()) {
            String name = (String) e.nextElement();
            out.printf("<input type=\"hidden\" name=\"%s\" value=\"%s\" />%n",
                    name,request.getParameter(name));
        }
    }
    private void printFormFooter() {
        out.println("</fieldset></form>");
    }

    void showMessageDialog(DisplayQueryResults view, String message, String title, int ERROR_MESSAGE) {

        String ok = request.getParameter(prefix+"MessageOK");
        if(ok != null) {
            return;
        }
        HtmlWriter.printHeader(out, title);
        printFormHeader();
        out.println("<p>"+message);
        out.println("</p><input type=\"submit\" value=\"OK\" name=\""+prefix+"MessageOK\" />");

        printFormFooter();
        HtmlWriter.printFooter(out);
        out.flush();
        throw new DialogException();
    }

    public static class DialogException extends RuntimeException {

    }
}